//
//  ValidatorSACtApp.m
//  Validator-SAC
//
//  Created by Chuck Houpt on 3/25/06.
//  Copyright 2006 Chuck Houpt. All rights reserved.
//

#import "ValidatorSACApp.h"

#import "PFMoveApplication.h"
#import "MyDocument.h"


@implementation ValidatorSACApp

+ (void)initialize {
	[[NSUserDefaults standardUserDefaults] setObject:@"YES" forKey:@"SUSendProfileInfo"];
}

- (void)finishLaunching {
	[super finishLaunching];
	
	// Offer to the move the Application if necessary.
	PFMoveToApplicationsFolderIfNecessary();
}


- (void)awakeFromNib
{
    NSAppleEventManager *eventManager = [NSAppleEventManager sharedAppleEventManager];
    [eventManager setEventHandler:self
                      andSelector:@selector(handleURLEvent:withReplyEvent:)
                    forEventClass:kInternetEventClass
                       andEventID:(AEEventID)kAEGetURL];
    [eventManager setEventHandler:self
                      andSelector:@selector(handleURLEvent:withReplyEvent:)
                    forEventClass:'WWW!'
                       andEventID:'OURL'];
}

- (void)handleURLEvent:(NSAppleEventDescriptor *)event withReplyEvent: (NSAppleEventDescriptor *)replyEvent
{
    // FIXME: Report errors (3193872).
    NSString *objectString = [[event paramDescriptorForKeyword:keyDirectObject] stringValue];
	NSString *URLString = nil;
	
	if ([objectString hasPrefix: @"x-validator-sac://open?uri="]) {
		URLString = [[objectString substringFromIndex: 27] stringByReplacingPercentEscapesUsingEncoding: NSUTF8StringEncoding];
		URLString = [URLString stringByAddingPercentEscapesUsingEncoding: NSUTF8StringEncoding];
	} else if ([objectString length]) {
		URLString = objectString;
	}
	
	if (URLString) {
		NSURL *URL = [NSURL URLWithString: URLString];
		MyDocument *document = [[NSDocumentController sharedDocumentController] openUntitledDocumentOfType:HTMLDocumentType display:YES];
		[document goToURL:URL];
	}
}

- (void)showHelp:(id)sender
{
	
	MyDocument *document = [[NSDocumentController sharedDocumentController] openUntitledDocumentOfType:HTMLDocumentType display:YES];
	if ([sender tag]) [document loadHTDocName:@"docs/index.html"];
	else [document loadHTDocName:@"docs/help.html"];
}

- (void)showSource:(id)sender
{
	NSBundle *thisBundle = [NSBundle bundleForClass:[self class]];
	
	NSString *source = [NSString stringWithFormat:@"%@/Contents/Source", [thisBundle bundlePath]];
	NSString *project = [NSString stringWithFormat:@"%@/Validator-SAC.xcodeproj", source];
	[[NSWorkspace sharedWorkspace] openFile:source];
	[[NSWorkspace sharedWorkspace] openFile:project];
}

@end
